#encoding: UTF-8 
=begin
/***************************************************************************
 *   ©2015-2015 Michael Uplawski <michael.uplawski@uplawski.eu>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
=end
require 'singleton'
require_relative 'logging'


=begin
	This singleton concentrates program options, received from
	somewhere. Currently, the options are set with the attribute-writer
	options=(). TODO: Evaluation of a configuration-file. Mind that 
	program-arguments, i.e. the parameter to the options=() setter, 
	must always take precedence !
=end
class Configuration
	include Singleton
	include Logging

	def initialize
		init_logger()
		@options = nil
	end

=begin
	Exclude that members of the included modules interfer.
=end
	def to_s
		@options.to_h.collect {|p| p[0].to_s << ': ' << p[1].to_s}.join(', ')
	end

	def method_missing(m, *args)
		if(@options.respond_to?(m))
			@options.send(m)
		else
			Object.method_missing(m, args)
		end
	end

	def options=(op)
		unless @options
			@options = op
			@log.level = @options.debug ? Logger::DEBUG : @def_log_level
			@log.debug('options will be ' << op.to_s)
		else
			# TODO: Think.
			@log.warn('Configuration options are already defined; no changes are applied')
		end
	end
	attr_reader :options

end
